#include <sstream>
#include <GL/glew.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#include <SDL/SDL_image.h>
#include <math.h>
#include <string>
#include <iostream>
#include <sstream>
#include <fstream>
#include <vector>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <sys/time.h>

#include "glm-0.9.2.6/glm/glm.hpp"
#include "glm-0.9.2.6/glm/gtc/matrix_transform.hpp"
#include "glm-0.9.2.6/glm/gtc/type_ptr.hpp"

#include "src/vec.h"
#include "src/common.h"
#include "src/enum.h"
#include "src/vector.h"
#include "src/keyboard.h"
#include "src/timer.h"
#include "src/matrix.h"
#include "src/glhelper.h"
#include "src/obj.h"
#include "src/object.h"


struct vertex_ {
	double x,  y,   z;
	double tx, ty, tz;
	double t[6];
};

int main(int argc, char* argv[]) {
	//__dimensions dim = {1920,1080};
	__dimensions dim = {1280,720};
	const int BPP = 24;
	const int MAX_BOUNCES = 12;
	
	cKeyboard kb;
	cTimer t0; double elapsed0;
  
	timespec current;
	clock_gettime(CLOCK_REALTIME, &current);
	srand(current.tv_sec + current.tv_nsec / 1000000000.0);
	
	bool active = true;
	unsigned int samples = 1;

	SDL_Init(SDL_INIT_EVERYTHING);
	SDL_Surface *screen = mySDLInit(dim.width, dim.height, BPP, false);
	SDL_Event event;

	std::vector<cObject*> objects;
 
	objects.push_back(new cPlane(vector3( 0, -1,  0), vector3( -16,   16, -16), vector3(  1,  1,  1)*0, vector3(1,1,1)*2,   DIFFUSE,  2, vector3(0,0,8), vector3(8,0,0))); // top
	objects.push_back(new cPlane(vector3( 0,  1,  0), vector3( -16,    0, -16), vector3(  1,  1,  1),   vector3(),          DIFFUSE,  1, vector3(8,0,0), vector3(0,0,8))); // bottom
	cObj monkey("monkey.obj");
	double scale = 8;//rand()/(double)RAND_MAX/4.0 + 0.25;
	vector3 translate(0,scale/2,2);
	for (int i = 0; i < MIN(20000,monkey.faces.size()); i++) {
		objects.push_back(new cTriangle(vector3(monkey.vertices[monkey.faces[i].vertex[0]].v[0], monkey.vertices[monkey.faces[i].vertex[0]].v[1], monkey.vertices[monkey.faces[i].vertex[0]].v[2]) * scale + translate,
						vector3(monkey.vertices[monkey.faces[i].vertex[1]].v[0], monkey.vertices[monkey.faces[i].vertex[1]].v[1], monkey.vertices[monkey.faces[i].vertex[1]].v[2]) * scale + translate,
						vector3(monkey.vertices[monkey.faces[i].vertex[2]].v[0], monkey.vertices[monkey.faces[i].vertex[2]].v[1], monkey.vertices[monkey.faces[i].vertex[2]].v[2]) * scale + translate,
						vector3(monkey.normals[monkey.faces[i].normal[0]].v[0], monkey.normals[monkey.faces[i].normal[0]].v[1], monkey.normals[monkey.faces[i].normal[0]].v[2]).unit(),
						vector3(monkey.normals[monkey.faces[i].normal[1]].v[0], monkey.normals[monkey.faces[i].normal[1]].v[1], monkey.normals[monkey.faces[i].normal[1]].v[2]).unit(),
						vector3(monkey.normals[monkey.faces[i].normal[2]].v[0], monkey.normals[monkey.faces[i].normal[2]].v[1], monkey.normals[monkey.faces[i].normal[2]].v[2]).unit(),
						vector3(1,1,1), vector3(0,0,0), DIFFUSE, -1) );
	}

/*// box scene
	objects.push_back(new cPlane(vector3( 0, -1,  0), vector3(   0,    4,   0), vector3(  1,  1,  1), vector3(),        DIFFUSE, -1, vector3(0,0,1), vector3(1,0,0))); // top
	objects.push_back(new cPlane(vector3( 0,  1,  0), vector3( -16,    0, -16), vector3(  1,  1,  1), vector3(),        DIFFUSE,  1, vector3(4,0,0), vector3(0,0,4))); // bottom
	objects.push_back(new cPlane(vector3( 1,  0,  0), vector3(  -4,    0,   0), vector3(  1,  0,  0), vector3(),        DIFFUSE, -1, vector3(0,1,0), vector3(0,0,1))); // left
	objects.push_back(new cPlane(vector3(-1,  0,  0), vector3(   4,    0,   0), vector3(  0,  0,  1), vector3(),        DIFFUSE, -1, vector3(0,1,0), vector3(0,0,1))); // right
	objects.push_back(new cPlane(vector3( 0,  0,  1), vector3(   0,    0,  -4), vector3(  1,  1,  1), vector3(),        DIFFUSE,  0, vector3(1,0,0), vector3(0,1,0))); // forward
	objects.push_back(new cPlane(vector3( 0,  0, -1), vector3(   0,    0,  17), vector3(  0,  0,  0), vector3(),        DIFFUSE, -1, vector3(1,0,0), vector3(0,1,0))); // behind

	// first light
	objects.push_back(new cTriangle(vector3(-2,3.9,-2), vector3(-2,3.9,2), vector3(2,3.9,2), vector3(0,-1,0).unit(), vector3(0,-1,0), vector3(0,-1,0), vector3(1,1,1), vector3(1,1,1)*2, DIFFUSE, -1));
	objects.push_back(new cTriangle(vector3(2,3.9,2), vector3(2,3.9,-2), vector3(-2,3.9,-2), vector3(0,-1,0).unit(), vector3(0,-1,0), vector3(0,-1,0), vector3(1,1,1), vector3(1,1,1)*2, DIFFUSE, -1));

	// second light
	objects.push_back(new cTriangle(vector3(-2,3.9,4), vector3(-2,3.9,8), vector3(2,3.9,8), vector3(0,-1,0).unit(), vector3(0,-1,0), vector3(0,-1,0), vector3(1,1,1), vector3(1,1,1)*2, DIFFUSE, -1));
	objects.push_back(new cTriangle(vector3(2,3.9,8), vector3(2,3.9,4), vector3(-2,3.9,4), vector3(0,-1,0).unit(), vector3(0,-1,0), vector3(0,-1,0), vector3(1,1,1), vector3(1,1,1)*2, DIFFUSE, -1));
	
	cObj cube("cube.obj");
	double scale = 1.5;//rand()/(double)RAND_MAX/4.0 + 0.25;
	vector3 translate(-2,scale/2,2);
	double radius = 1;
	objects.push_back(new cSphere(vector3(2,1,4), 1, vector3(1,1,1), vector3(), REFRACTIVE, -1));
	objects.push_back(new cSphere(vector3(-2,scale+radius,2), radius, vector3(1,1,1), vector3(), SPECULAR, -1));
	for (int i = 0; i < MIN(20000,cube.faces.size()); i++) {
		objects.push_back(new cTriangle(vector3(cube.vertices[cube.faces[i].vertex[0]].v[0], cube.vertices[cube.faces[i].vertex[0]].v[1], cube.vertices[cube.faces[i].vertex[0]].v[2]) * scale + translate,
						vector3(cube.vertices[cube.faces[i].vertex[1]].v[0], cube.vertices[cube.faces[i].vertex[1]].v[1], cube.vertices[cube.faces[i].vertex[1]].v[2]) * scale + translate,
						vector3(cube.vertices[cube.faces[i].vertex[2]].v[0], cube.vertices[cube.faces[i].vertex[2]].v[1], cube.vertices[cube.faces[i].vertex[2]].v[2]) * scale + translate,
						vector3(cube.normals[cube.faces[i].normal[0]].v[0], cube.normals[cube.faces[i].normal[0]].v[1], cube.normals[cube.faces[i].normal[0]].v[2]).unit(),
						vector3(cube.normals[cube.faces[i].normal[1]].v[0], cube.normals[cube.faces[i].normal[1]].v[1], cube.normals[cube.faces[i].normal[1]].v[2]).unit(),
						vector3(cube.normals[cube.faces[i].normal[2]].v[0], cube.normals[cube.faces[i].normal[2]].v[1], cube.normals[cube.faces[i].normal[2]].v[2]).unit(),
						vector3(1,1,1), vector3(0,0,0), DIFFUSE, -1) );
	}
*/

	// set up the camera matrix and apply it to the primitives
	int frame = 0;

//	vector3 origin(sin(frame/360.0*2.0*3.14159265359)*2.5,  2,  cos(frame/360.0*2.0*3.14159265359)*2.5);
	vector3 origin(-1,8,16);
	vector3 forward = (vector3(0,3,2)-origin).unit();
	vector3 up(0.05, 1,  0); up = up.unit();
	applyCamera(origin, forward, up, objects);

	
	unsigned char *current_buffer_host;
	unsigned char *current_buffer_device;
	double *current_doubles_device;
	__object *current_objects_device;
	float *rand_device;
	_bounding_box b;

	
	// copy the transformed objects into an __object array
	__object _objects[objects.size()];
	__box bounds = {1e8,1e8,1e8,-1e8,-1e8,-1e8};
	copyObjects(objects, _objects, bounds);

	std::cout << "tst " <<  _objects[4].point.x << " " << _objects[4].point.y << " " << _objects[4].point.z << std::endl;
	std::cout << "tst " <<  _objects[4].normal.x << " " << _objects[4].normal.y << " " << _objects[4].normal.z << std::endl;
	
	// set up the camera model
	_camera cmodel;
	cmodel.focal_length = 35.0 / 1000.0;
	cmodel.aperture = 0.5;//1.0;
	cmodel.focal_distance = sqrt(pow((bounds.minx+bounds.maxx)/2.0,2.0)+pow((bounds.miny+bounds.maxy)/2.0,2.0)+pow((bounds.minz+bounds.maxz)/2.0,2.0)); // focal point at center of objects
	cmodel.image_distance = 1.0 / (1.0 / cmodel.focal_length - 1.0 / cmodel.focal_distance); // thin lens
	cmodel.aperture_diameter = cmodel.focal_length / cmodel.aperture;

	__textures tex;
	tex.count = 0;
	tex.texture[tex.count] = loadImage("grid.png", tex.width[tex.count], tex.height[tex.count], tex.bpp[tex.count]); tex.count++;
	tex.texture[tex.count] = loadImage("tile.jpg", tex.width[tex.count], tex.height[tex.count], tex.bpp[tex.count]); tex.count++;
	tex.texture[tex.count] = loadImage("clouds.jpg", tex.width[tex.count], tex.height[tex.count], tex.bpp[tex.count]); tex.count++;

	initializePathTracer(b, current_buffer_host, current_buffer_device, current_doubles_device, _objects, current_objects_device, objects.size(), rand_device, MAX_BOUNCES, dim, bounds, tex);

	for (int i = 0; i < tex.count; i++) delete tex.texture[i];
	
        setupPathTracer(b, current_doubles_device, _objects, current_objects_device, objects.size(), dim, bounds);

	// shaders
	GLuint glProgram, glShaderV, glShaderF;
	GLint vertex, texCoord, Projection, View, Model, textureSample;
	createProgram(glProgram, glShaderV, glShaderF, "src/vertex.sh", "src/fragment.sh");
	vertex        = glGetAttribLocation(glProgram, "vertex");
	texCoord      = glGetAttribLocation(glProgram, "texCoord");
	Projection    = glGetUniformLocation(glProgram, "Projection");
	View          = glGetUniformLocation(glProgram, "View");
	Model         = glGetUniformLocation(glProgram, "Model");
	textureSample = glGetUniformLocation(glProgram, "textureSample");

	// vertices
	const int vertex_count = 4;
	vertex_ vertices[vertex_count];
	vertices[0].x  = 0;         vertices[0].y  = 0;          vertices[0].z = 0;     vertices[0].tx = 0;     vertices[0].ty = 0;	
	vertices[1].x  = dim.width; vertices[1].y  = 0;          vertices[1].z = 0;     vertices[1].tx = 1;     vertices[1].ty = 0;	
	vertices[2].x  = dim.width; vertices[2].y  = dim.height; vertices[2].z = 0;     vertices[2].tx = 1;     vertices[2].ty = 1;
	vertices[3].x  = 0;         vertices[3].y  = dim.height; vertices[3].z = 0;     vertices[3].tx = 0;     vertices[3].ty = 1;
	GLuint vbo_vertices;
	glGenBuffers(1, &vbo_vertices);
	glBindBuffer(GL_ARRAY_BUFFER, vbo_vertices);
	glBufferData(GL_ARRAY_BUFFER, sizeof(vertex_) * vertex_count, vertices, GL_DYNAMIC_DRAW);

	// indices
	const int indices_count = 6;
	unsigned int indices[indices_count] = {0, 1, 2, 2, 3, 0};
	GLuint vbo_indices;
	glGenBuffers(1, &vbo_indices);
	glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, vbo_indices);
	glBufferData(GL_ELEMENT_ARRAY_BUFFER, sizeof(unsigned int) * indices_count, indices, GL_STATIC_DRAW);

	// create a texture for rendering the result
	GLuint texture;
	setupTexture(texture);

	glm::mat4 projection = glm::ortho(0.0f, (float)dim.width, (float)dim.height, 0.0f, -5.0f, 5.0f); 
	glm::mat4 view       = glm::mat4(1.0f);
	glm::mat4 model      = glm::mat4(1.0f);

	__offsets offset = {0,0};
	bool sleep = false;
	while (active) {

		while (SDL_PollEvent(&event)) {
			switch (event.type) {
			    case SDL_QUIT: active = false; break;
			}
		}

		elapsed0 = t0.elapsed(true);

		if (kb.getKeyState(KEY_SPACE))    { sleep =  true; }
		if (kb.getKeyState(KEY_G))        { sleep = false; }
		
		if (sleep) {
			usleep(100000);
		} else {
			runPathTracer(b, current_buffer_host, current_buffer_device, current_doubles_device, current_objects_device, objects.size(), rand_device, MAX_BOUNCES, dim, offset, samples, cmodel, tex);
			std::cout << "samples: " << (int)samples << std::endl;

			glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
			glUseProgram(glProgram);

			// texture
			glUniform1i(textureSample, 0);
			glActiveTexture(GL_TEXTURE0);
			glBindTexture(GL_TEXTURE_2D, texture);
			glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, dim.width, dim.height, 0, GL_RGB, GL_UNSIGNED_BYTE, current_buffer_host);

			// Project, View, and Model uniforms
			glUniformMatrix4fv(Projection, 1, GL_FALSE, glm::value_ptr(projection));
			glUniformMatrix4fv(View, 1, GL_FALSE, glm::value_ptr(view));
			//model = glm::translate(glm::mat4(1.0f), glm::vec3(0.0f,0.0f,-2.0f));
			glUniformMatrix4fv(Model, 1, GL_FALSE, glm::value_ptr(model));

			// vertex and texture attributes
			glBindBuffer(GL_ARRAY_BUFFER, vbo_vertices);
			glEnableVertexAttribArray(vertex);
			glVertexAttribPointer(vertex, 3, GL_DOUBLE, GL_FALSE, sizeof(vertex_), 0);
			glEnableVertexAttribArray(texture);
			glVertexAttribPointer(texCoord, 2, GL_DOUBLE, GL_FALSE, sizeof(vertex_), (char *)NULL + 24);

			// draw it
			glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, vbo_indices);
			glDrawElements(GL_TRIANGLES, indices_count, GL_UNSIGNED_INT, 0);
			SDL_GL_SwapBuffers();
			
			offset.x += 128;
			if (offset.x >= dim.width) { // (dim.width - 128)) {
				offset.x = 0;
				offset.y += 128;
				if (offset.y >= dim.height) { // (dim.height - 128)) {
					offset.x = offset.y = 0;
					/*if (samples % 50 == 0) {
						std::stringstream s;
						s << "screen" << (int)samples << ".ppm";
						savePPM(current_buffer_host, dim.width, dim.height, BPP, s.str().c_str());
					}*/
					samples++;

					grabFrame(current_buffer_host, current_buffer_device, dim);

					if (samples == 2000000) { // this is used to animate -- camera position changes every n frames

						samples = 1;
						frame += 1;
						std::stringstream s;
						s << "frame" << (frame < 10 ? "000" : (frame < 100 ? "00" : "0")) << frame << ".ppm";
						savePPM(current_buffer_host, dim.width, dim.height, BPP, s.str().c_str());

						vector3 origin(sin(frame/360.0*2.0*3.14159265359)*2.5,  2,  cos(frame/360.0*2.0*3.14159265359)*2.5);
						vector3 forward = (vector3(0,0.5,0)-origin).unit();
						vector3 up(0, 1,  0);
						applyCamera(origin, forward, up, objects);

						bounds = {1e8,1e8,1e8,-1e8,-1e8,-1e8};
						copyObjects(objects, _objects, bounds);

					        setupPathTracer(b, current_doubles_device, _objects, current_objects_device, objects.size(), dim, bounds);
					}
				}
			}
		}

	}

	savePPM(current_buffer_host, dim.width, dim.height, BPP, "screen.ppm");
	
	releasePathTracer(b, current_buffer_host, current_buffer_device, current_doubles_device, current_objects_device, rand_device, tex);

	// release the objects
	for (int i = 0; i < objects.size(); i++) delete objects[i];
	
	// release the texture, vertex buffer objects, and shader program.. also shut down SDL
	deleteTexture(texture);
	glDeleteBuffers(1, &vbo_indices);
	glDeleteBuffers(1, &vbo_vertices);
	releaseProgram(glProgram, glShaderV, glShaderF);

	SDL_Quit();

	return 0;
}